<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Ip6::Udp Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('de/ded/classThread_1_1Ip6_1_1Udp.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="../../d1/d6a/classThread_1_1Ip6_1_1Udp-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Ip6::Udp Class Reference<div class="ingroups"><a class="el" href="../../d0/de1/group__core.html">Core</a> &raquo; <a class="el" href="../../db/daa/group__core-udp.html">UDP</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This class implements core UDP message handling.  
 <a href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../d0/db7/udp6_8hpp_source.html">src/core/net/udp6.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae5bb3f296710b0648e8ec38c81340ad6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#ae5bb3f296710b0648e8ec38c81340ad6">Udp</a> (<a class="el" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6</a> &amp;aIp6)</td></tr>
<tr class="memdesc:ae5bb3f296710b0648e8ec38c81340ad6"><td class="mdescLeft">&#160;</td><td class="mdescRight">This constructor initializes the object.  <a href="#ae5bb3f296710b0648e8ec38c81340ad6">More...</a><br /></td></tr>
<tr class="separator:ae5bb3f296710b0648e8ec38c81340ad6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36da6039e1c4a6bd9f8a123cea276adc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#a36da6039e1c4a6bd9f8a123cea276adc">AddSocket</a> (<a class="el" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">UdpSocket</a> &amp;aSocket)</td></tr>
<tr class="memdesc:a36da6039e1c4a6bd9f8a123cea276adc"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method adds a UDP socket.  <a href="#a36da6039e1c4a6bd9f8a123cea276adc">More...</a><br /></td></tr>
<tr class="separator:a36da6039e1c4a6bd9f8a123cea276adc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abada2f7d6b56caaf4a5a686a86c32428"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#abada2f7d6b56caaf4a5a686a86c32428">RemoveSocket</a> (<a class="el" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">UdpSocket</a> &amp;aSocket)</td></tr>
<tr class="memdesc:abada2f7d6b56caaf4a5a686a86c32428"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method removes a UDP socket.  <a href="#abada2f7d6b56caaf4a5a686a86c32428">More...</a><br /></td></tr>
<tr class="separator:abada2f7d6b56caaf4a5a686a86c32428"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13473099ea53876a2f722c938e7081d8"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#a13473099ea53876a2f722c938e7081d8">GetEphemeralPort</a> (void)</td></tr>
<tr class="memdesc:a13473099ea53876a2f722c938e7081d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method returns a new ephemeral port.  <a href="#a13473099ea53876a2f722c938e7081d8">More...</a><br /></td></tr>
<tr class="separator:a13473099ea53876a2f722c938e7081d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe746fb2f5c83a97c20e54fdb9c595a3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#afe746fb2f5c83a97c20e54fdb9c595a3">NewMessage</a> (uint16_t aReserved)</td></tr>
<tr class="memdesc:afe746fb2f5c83a97c20e54fdb9c595a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method returns a new UDP message with sufficient header space reserved.  <a href="#afe746fb2f5c83a97c20e54fdb9c595a3">More...</a><br /></td></tr>
<tr class="separator:afe746fb2f5c83a97c20e54fdb9c595a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8d41afcd7a8894a7005bc1c32343f7d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#aa8d41afcd7a8894a7005bc1c32343f7d">SendDatagram</a> (<a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <a class="el" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo, <a class="el" href="../../d9/dcf/group__core-ip6-ip6.html#ga83d94b02a618038e1534f9e12001d095">IpProto</a> aIpProto)</td></tr>
<tr class="memdesc:aa8d41afcd7a8894a7005bc1c32343f7d"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sends an IPv6 datagram.  <a href="#aa8d41afcd7a8894a7005bc1c32343f7d">More...</a><br /></td></tr>
<tr class="separator:aa8d41afcd7a8894a7005bc1c32343f7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f645b8190d7e4345fbc195db5b03e49"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#a3f645b8190d7e4345fbc195db5b03e49">HandleMessage</a> (<a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <a class="el" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;aMessageInfo)</td></tr>
<tr class="memdesc:a3f645b8190d7e4345fbc195db5b03e49"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method handles a received UDP message.  <a href="#a3f645b8190d7e4345fbc195db5b03e49">More...</a><br /></td></tr>
<tr class="separator:a3f645b8190d7e4345fbc195db5b03e49"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6462f860311b25afef6cb90805dd778"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#aa6462f860311b25afef6cb90805dd778">UpdateChecksum</a> (<a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, uint16_t aPseudoHeaderChecksum)</td></tr>
<tr class="memdesc:aa6462f860311b25afef6cb90805dd778"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method updates the UDP checksum.  <a href="#aa6462f860311b25afef6cb90805dd778">More...</a><br /></td></tr>
<tr class="separator:aa6462f860311b25afef6cb90805dd778"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:ae128c6687ced82c6157c5f865f8dec5c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae128c6687ced82c6157c5f865f8dec5c"></a>
class&#160;</td><td class="memItemRight" valign="bottom"><b>UdpSocket</b></td></tr>
<tr class="separator:ae128c6687ced82c6157c5f865f8dec5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements core UDP message handling. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ae5bb3f296710b0648e8ec38c81340ad6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Thread::Ip6::Udp::Udp </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html">Ip6</a> &amp;&#160;</td>
          <td class="paramname"><em>aIp6</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This constructor initializes the object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aIp6</td><td>A reference to the IPv6 network object. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a36da6039e1c4a6bd9f8a123cea276adc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Ip6::Udp::AddSocket </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">UdpSocket</a> &amp;&#160;</td>
          <td class="paramname"><em>aSocket</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method adds a UDP socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aSocket</td><td>A reference to the UDP socket.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added the UDP socket. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a13473099ea53876a2f722c938e7081d8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t Thread::Ip6::Udp::GetEphemeralPort </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method returns a new ephemeral port. </p>
<dl class="section return"><dt>Returns</dt><dd>A new ephemeral port. </dd></dl>

</div>
</div>
<a class="anchor" id="a3f645b8190d7e4345fbc195db5b03e49"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Ip6::Udp::HandleMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessageInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method handles a received UDP message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A reference to the UDP message to process. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessageInfo</td><td>A reference to the message info associated with <code>aMessage</code>.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully processed the UDP message. </td></tr>
    <tr><td class="paramname">kThreadError_Drop</td><td>Could not fully process the UDP message. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_cgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_cgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_cgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_cgraph">
<area shape="rect" id="node2" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="246,5,441,31"/>
<area shape="rect" id="node3" href="../../dc/d3c/classThread_1_1Message.html#ac8304ee00c9e0b303539687e98e192e0" title="This method returns the byte offset within the message. " alt="" coords="249,55,438,80"/>
<area shape="rect" id="node4" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a5f39ba98f1e62d4b618aa83ac8c047b6" title="This static method computes the pseudoheader checksum. " alt="" coords="255,104,432,143"/>
<area shape="rect" id="node6" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a794b87e17aa877f3551c00aa8c892072" title="This method returns a reference to the peer socket address. " alt="" coords="257,167,430,205"/>
<area shape="rect" id="node7" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a97e94677a677f600a227dd970f4a02e8" title="This method returns a reference to the local socket address. " alt="" coords="257,229,430,268"/>
<area shape="rect" id="node8" href="../../dc/d3c/classThread_1_1Message.html#a97e576ca01bc7a858f2d5cd35c82b731" title="This method is used to update a checksum value. " alt="" coords="224,292,463,317"/>
<area shape="rect" id="node10" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="261,341,426,367"/>
<area shape="rect" id="node11" href="../../dc/d3c/classThread_1_1Message.html#a7b45edaa8ba9f31a437aea73cfca387c" title="This method moves the byte offset within the message. " alt="" coords="243,391,444,416"/>
<area shape="rect" id="node12" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a83d995609237751bce5a8905c0bf837f" title="This method returns the UDP Source Port. " alt="" coords="261,440,426,479"/>
<area shape="rect" id="node13" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a21cbe8e5d4940ca6192f2fa58636c8cc" title="This method returns the UDP Destination Port. " alt="" coords="261,503,426,541"/>
<area shape="rect" id="node14" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a37b709740053966d80e6c4b65e38ad2e" title="This method indicates whether or not the IPv6 address is multicast address. " alt="" coords="271,565,417,604"/>
<area shape="rect" id="node5" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a65af4f070c4734601f0308ab48affba8" title="This static method updates a checksum. " alt="" coords="527,180,693,219"/>
<area shape="rect" id="node9" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="511,317,709,343"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_icgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_icgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_icgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_a3f645b8190d7e4345fbc195db5b03e49_icgraph">
<area shape="rect" id="node2" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a4aa215eb5c0d575403b5ca683e8427c2" title="This method sends an IPv6 datagram. " alt="" coords="224,140,437,165"/>
<area shape="rect" id="node3" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#a8989f736211cf82f9cefb258decd7c3e" title="This method sends an ICMPv6 Echo Request message. " alt="" coords="804,5,938,44"/>
<area shape="rect" id="node5" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#a1652c3864180133512f7d6499cd684f2" title="This method sends an ICMPv6 error message. " alt="" coords="528,71,661,109"/>
<area shape="rect" id="node15" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#ad28878461d364df3eeac50588479c9c1" title="This method handles an ICMPv6 message. " alt="" coords="528,133,661,172"/>
<area shape="rect" id="node16" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#aa8d41afcd7a8894a7005bc1c32343f7d" title="This method sends an IPv6 datagram. " alt="" coords="485,196,703,221"/>
<area shape="rect" id="node4" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2128,76,2283,115"/>
<area shape="rect" id="node6" href="../../df/d94/group__core-mle-core.html#ga27bbb63f94a4f59d1249fce8baa830ed" title="This method checks if the destination is reachable. " alt="" coords="751,77,991,103"/>
<area shape="rect" id="node7" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1039,121,1200,160"/>
<area shape="rect" id="node8" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1248,121,1412,160"/>
<area shape="rect" id="node10" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1460,184,1630,223"/>
<area shape="rect" id="node9" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1463,59,1627,97"/>
<area shape="rect" id="node14" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1475,121,1615,160"/>
<area shape="rect" id="node11" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="1678,156,1859,181"/>
<area shape="rect" id="node12" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="1907,93,2080,132"/>
<area shape="rect" id="node13" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="1951,156,2035,181"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="afe746fb2f5c83a97c20e54fdb9c595a3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> * Thread::Ip6::Udp::NewMessage </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aReserved</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method returns a new UDP message with sufficient header space reserved. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aReserved</td><td>The number of header bytes to reserve after the UDP header.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the message or NULL if no buffers are available. </dd></dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_cgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_cgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_cgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_cgraph">
<area shape="rect" id="node2" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a215eeb84e75972828efbc163eedc1ec5" title="This method allocates a new message buffer from the buffer pool. " alt="" coords="263,68,467,93"/>
<area shape="rect" id="node3" href="../../d5/d9f/classThread_1_1MessagePool.html#a2d10b04dfeb1e0c9321eab0e95fda55f" title="This method is used to obtain a new message. " alt="" coords="515,68,700,93"/>
<area shape="rect" id="node4" href="../../dc/d3c/classThread_1_1Message.html#a942818bf261c0af93b793017407c2b2c" title="This method sets whether or not link security is enabled for the message. " alt="" coords="757,5,934,44"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#acecf07ee065974c8b211c151ea5d6e14" title="This method sets the number of bytes in the message. " alt="" coords="748,68,942,93"/>
<area shape="rect" id="node6" href="../../d5/d9f/classThread_1_1MessagePool.html#a80238d94036455e30762ea4a5a0916f8" title="This method is used to free a message and return all message buffers to the buffer pool..." alt="" coords="769,117,921,156"/>
<area shape="rect" id="node7" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="990,99,1188,124"/>
<area shape="rect" id="node8" href="../../db/d50/classThread_1_1Buffer.html#a437ec9ccafa1ef6040a6e8e4fae9c3ca" title="This method sets the pointer to the next message buffer. " alt="" coords="990,148,1187,173"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_icgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_icgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_icgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_afe746fb2f5c83a97c20e54fdb9c595a3_icgraph">
<area shape="rect" id="node2" href="../../d2/d11/group__udp.html#ga830b1fac9ad667bbedc0e68da91e70aa" title="Allocate a new message buffer for sending a UDP message. " alt="" coords="263,12,401,37"/>
<area shape="rect" id="node3" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#a50e5829bd74bf2845d8313575e2dd15c" title="This method delivers raw characters to the client. " alt="" coords="449,12,614,37"/>
<area shape="rect" id="node4" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab8ac2489d2049ef5880c77ac1cdc639f" title="This method delivers formatted output to the client. " alt="" coords="662,5,828,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="abada2f7d6b56caaf4a5a686a86c32428"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Ip6::Udp::RemoveSocket </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html">UdpSocket</a> &amp;&#160;</td>
          <td class="paramname"><em>aSocket</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method removes a UDP socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aSocket</td><td>A reference to the UDP socket.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully removed the UDP socket. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa8d41afcd7a8894a7005bc1c32343f7d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Ip6::Udp::SendDatagram </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html">MessageInfo</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessageInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/dcf/group__core-ip6-ip6.html#ga83d94b02a618038e1534f9e12001d095">IpProto</a>&#160;</td>
          <td class="paramname"><em>aIpProto</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sends an IPv6 datagram. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A reference to the message. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessageInfo</td><td>A reference to the message info associated with <code>aMessage</code>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aIpProto</td><td>The Internet Protocol value.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully enqueued the message into an output interface. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient available buffer to add the IPv6 headers. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_aa8d41afcd7a8894a7005bc1c32343f7d_cgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_aa8d41afcd7a8894a7005bc1c32343f7d_cgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_aa8d41afcd7a8894a7005bc1c32343f7d_cgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_aa8d41afcd7a8894a7005bc1c32343f7d_cgraph">
<area shape="rect" id="node2" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a4aa215eb5c0d575403b5ca683e8427c2" title="This method sends an IPv6 datagram. " alt="" coords="272,1377,484,1402"/>
<area shape="rect" id="node3" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="802,1076,997,1101"/>
<area shape="rect" id="node4" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#ae759dab83ad87de26f3e5661d4331a54" title="This method initializes the IPv6 header. " alt="" coords="571,52,711,90"/>
<area shape="rect" id="node5" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#aec92bb6790fffab9ddb424d85a1e39b3" title="This method sets the IPv6 Payload Length value. " alt="" coords="571,114,711,153"/>
<area shape="rect" id="node6" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#afc6dbaaca33c8996ce396195cb6f8978" title="This method sets the IPv6 Next Header value. " alt="" coords="571,177,711,216"/>
<area shape="rect" id="node7" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#a60add06692d13d0b9ff26d1d1459cafa" title="This method sets the IPv6 Hop Limit value. " alt="" coords="829,428,970,466"/>
<area shape="rect" id="node8" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a97e94677a677f600a227dd970f4a02e8" title="This method returns a reference to the local socket address. " alt="" coords="813,1472,986,1510"/>
<area shape="rect" id="node9" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a51cfd76548da9f661a0d7a47a8d5e813" title="This method indicates whether or not the IPv6 address is the Unspecified Address. ..." alt="" coords="568,354,714,393"/>
<area shape="rect" id="node10" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a5ba0f65f507234b1f228b7249af6f1ee" title="This method perform default source address selection. " alt="" coords="561,240,721,278"/>
<area shape="rect" id="node11" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a794b87e17aa877f3551c00aa8c892072" title="This method returns a reference to the peer socket address. " alt="" coords="813,753,986,792"/>
<area shape="rect" id="node12" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a95748f9c0a5048ce8700cd040d7efc52" title="This method indicates whether or not the IPv6 address scope is Link&#45;Local. " alt="" coords="826,297,972,336"/>
<area shape="rect" id="node13" href="../../d9/d13/classThread_1_1Ip6_1_1NetifUnicastAddress.html#a2bb426bd29e271bd1fc09b61d1044911" title="This method returns the unicast address. " alt="" coords="815,114,984,153"/>
<area shape="rect" id="node14" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#a73e5209e71173a59f2295cbbc905e296" title="This method sets the IPv6 Source address. " alt="" coords="571,633,711,672"/>
<area shape="rect" id="node15" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#ab519252dba4f3843a511aec35a8a0756" title="This method sets the IPv6 Destination address. " alt="" coords="571,696,711,734"/>
<area shape="rect" id="node16" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#a24b065a50a342b00d2d8907b2fb3a66a" title="This method returns the IPv6 Destination address. " alt="" coords="829,498,970,537"/>
<area shape="rect" id="node17" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a25eecfa3d5faa101e497e8fde3964e13" title="This method indicates whether or not the IPv6 address is a link&#45;local multicast address. " alt="" coords="567,810,715,849"/>
<area shape="rect" id="node18" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#ab70000abd6ac0e216974ab012d4159d6" title="This method indicates whether or not the IPv6 address is a realm&#45;local multicast address. " alt="" coords="560,873,722,912"/>
<area shape="rect" id="node19" href="../../dc/d3c/classThread_1_1Message.html#a9c900e4c1ddbb44f1d9c87d10172f63a" title="This method prepends bytes to the front of the message. " alt="" coords="549,936,732,961"/>
<area shape="rect" id="node20" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a5f39ba98f1e62d4b618aa83ac8c047b6" title="This static method computes the pseudoheader checksum. " alt="" coords="811,1898,988,1937"/>
<area shape="rect" id="node21" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html#a6cc72334ebe32da12f67b0389b9bae21" title="This method returns the IPv6 Source address. " alt="" coords="829,566,970,605"/>
<area shape="rect" id="node22" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#aa6462f860311b25afef6cb90805dd778" title="This method updates the UDP checksum. " alt="" coords="555,1100,727,1138"/>
<area shape="rect" id="node23" href="../../dc/d3c/classThread_1_1Message.html#ac8304ee00c9e0b303539687e98e192e0" title="This method returns the byte offset within the message. " alt="" coords="805,1250,994,1276"/>
<area shape="rect" id="node24" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#a872e20ca6e8737eaf91db859041e10f7" title="This method updates the ICMPv6 checksum. " alt="" coords="574,1037,707,1076"/>
<area shape="rect" id="node25" href="../../dc/d3c/classThread_1_1Message.html#a8603ae822ebd6eaabef59fcd16d5667d" title="This method sets the interface ID. " alt="" coords="533,1265,749,1290"/>
<area shape="rect" id="node26" href="../../da/d1a/classThread_1_1MessageQueue.html#a5e6f37c86a48e8dfbfcc7a7c14c23808" title="This method adds a message to the end of the list. " alt="" coords="558,1314,723,1353"/>
<area shape="rect" id="node27" href="../../d4/d92/classThread_1_1Tasklet.html#a50a39a6f422851035b89aace87482425" title="This method puts the tasklet on the run queue. " alt="" coords="568,1377,714,1402"/>
<area shape="rect" id="node28" href="../../da/d1a/classThread_1_1MessageQueue.html#ac0e8b64309aca4d66b262f0354d72e83" title="This method returns a pointer to the first message. " alt="" coords="558,1426,723,1465"/>
<area shape="rect" id="node29" href="../../da/d1a/classThread_1_1MessageQueue.html#a501d831849c577b2114fcbb4034d074d" title="This method removes a message from the list. " alt="" coords="558,1489,723,1528"/>
<area shape="rect" id="node30" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#aac26950e3836c09b286ec241ced9d2c6" title="This method processes a received IPv6 datagram. " alt="" coords="558,570,723,609"/>
<area shape="rect" id="node31" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="817,1621,981,1646"/>
<area shape="rect" id="node32" href="../../dc/d3c/classThread_1_1Message.html#a34004dc217702d4a9ba3ddcbf2d91f74" title="This method returns the interface ID. " alt="" coords="532,1677,749,1702"/>
<area shape="rect" id="node33" href="../../de/df0/classThread_1_1Ip6_1_1ExtensionHeader.html#a9494816a3cf63e9bf4c637485f301cf6" title="This method returns the IPv6 Header Extension Length value. " alt="" coords="541,1726,740,1765"/>
<area shape="rect" id="node34" href="../../dc/d3c/classThread_1_1Message.html#a7b45edaa8ba9f31a437aea73cfca387c" title="This method moves the byte offset within the message. " alt="" coords="799,2276,999,2301"/>
<area shape="rect" id="node35" href="../../d2/d7c/classThread_1_1Ip6_1_1OptionHeader.html#a5526d213a992d14362a9eb8387a4403f" title="This method returns the IPv6 Option Type value. " alt="" coords="551,1841,731,1880"/>
<area shape="rect" id="node36" href="../../dd/d60/classThread_1_1Ip6_1_1Mpl.html#a0a337fec22aa43fcf36038761a6a8900" title="This method processes an MPL option. " alt="" coords="554,1552,728,1590"/>
<area shape="rect" id="node37" href="../../d2/d7c/classThread_1_1Ip6_1_1OptionHeader.html#ae5d9638cee80149e0a3f2116aba422ff" title="This method returns the IPv6 Option action for unrecognized IPv6 Options. " alt="" coords="551,1956,731,1994"/>
<area shape="rect" id="node38" href="../../d2/d7c/classThread_1_1Ip6_1_1OptionHeader.html#ac284bc7a465a12b3a2ac20927ecda327" title="This method returns the IPv6 Option Length value. " alt="" coords="551,2018,731,2057"/>
<area shape="rect" id="node39" href="../../d6/d56/classThread_1_1Ip6_1_1FragmentHeader.html#a6d9809c6894727de7750600ecaa7fbca" title="This method returns the Fragment Offset value. " alt="" coords="542,2081,740,2120"/>
<area shape="rect" id="node40" href="../../d6/d56/classThread_1_1Ip6_1_1FragmentHeader.html#a1116d92ecdb212ff53468c483f9d7688" title="This method returns the M flag value. " alt="" coords="542,2144,740,2182"/>
<area shape="rect" id="node41" href="../../de/df0/classThread_1_1Ip6_1_1ExtensionHeader.html#a68764e95bf4a7ac8c85463822ae756b8" title="This method returns the IPv6 Next Header value. " alt="" coords="541,2206,740,2245"/>
<area shape="rect" id="node42" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#a3f645b8190d7e4345fbc195db5b03e49" title="This method handles a received UDP message. " alt="" coords="555,1614,726,1653"/>
<area shape="rect" id="node43" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a21cbe8e5d4940ca6192f2fa58636c8cc" title="This method returns the UDP Destination Port. " alt="" coords="817,2088,982,2126"/>
<area shape="rect" id="node44" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#ad28878461d364df3eeac50588479c9c1" title="This method handles an ICMPv6 message. " alt="" coords="574,2269,707,2308"/>
<area shape="rect" id="node45" href="../../d2/de0/classThread_1_1Ip6_1_1IcmpHeader.html#ad51a0764c274f4d82fd23a99fa1e6800" title="This method returns the ICMPv6 message type. " alt="" coords="814,2350,984,2389"/>
<area shape="rect" id="node46" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a215eeb84e75972828efbc163eedc1ec5" title="This method allocates a new message buffer from the buffer pool. " alt="" coords="797,2461,1001,2486"/>
<area shape="rect" id="node47" href="../../dc/d3c/classThread_1_1Message.html#acecf07ee065974c8b211c151ea5d6e14" title="This method sets the number of bytes in the message. " alt="" coords="803,2536,996,2561"/>
<area shape="rect" id="node48" href="../../dc/d3c/classThread_1_1Message.html#a6ad07f345f6fbc1c0917d2ccf5ce9042" title="This method copies bytes from one message to another. " alt="" coords="810,2586,988,2612"/>
<area shape="rect" id="node49" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a042097e2896ce7eebc1844140c0d2aeb" title="This method indicates whether or not the IPv6 address is a RLOC address. " alt="" coords="568,2637,714,2676"/>
<area shape="rect" id="node50" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#af4cae4712ae9ef69a40f856a1ee32116" title="This method indicates whether or not ICMPv6 Echo processing is enabled. " alt="" coords="574,2700,707,2738"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="aa6462f860311b25afef6cb90805dd778"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Ip6::Udp::UpdateChecksum </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aPseudoHeaderChecksum</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method updates the UDP checksum. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A reference to the UDP message. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aPseudoHeaderChecksum</td><td>The pseudo-header checksum value.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully updated the UDP checksum. </td></tr>
    <tr><td class="paramname">kThreadError_InvalidArgs</td><td>The message was invalid. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_cgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_cgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_cgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_cgraph">
<area shape="rect" id="node2" href="../../dc/d3c/classThread_1_1Message.html#a97e576ca01bc7a858f2d5cd35c82b731" title="This method is used to update a checksum value. " alt="" coords="225,12,464,37"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#ac8304ee00c9e0b303539687e98e192e0" title="This method returns the byte offset within the message. " alt="" coords="250,61,439,87"/>
<area shape="rect" id="node6" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="247,111,442,136"/>
<area shape="rect" id="node7" href="../../dc/d3c/classThread_1_1Message.html#add75c76a1fa70eb5d4eb03b68c5d1df8" title="This method writes bytes to the message. " alt="" coords="263,160,426,185"/>
<area shape="rect" id="node8" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#adb6ca8f7e1f62ee5b7669daeb2eb3db6" title="This static method returns the byte offset for the UDP Checksum. " alt="" coords="262,209,427,248"/>
<area shape="rect" id="node3" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a65af4f070c4734601f0308ab48affba8" title="This static method updates a checksum. " alt="" coords="528,5,694,44"/>
<area shape="rect" id="node4" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="512,113,710,139"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_icgraph.png" border="0" usemap="#de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_icgraph" alt=""/></div>
<map name="de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_icgraph" id="de/ded/classThread_1_1Ip6_1_1Udp_aa6462f860311b25afef6cb90805dd778_icgraph">
<area shape="rect" id="node2" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a4aa215eb5c0d575403b5ca683e8427c2" title="This method sends an IPv6 datagram. " alt="" coords="225,140,438,165"/>
<area shape="rect" id="node3" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#a8989f736211cf82f9cefb258decd7c3e" title="This method sends an ICMPv6 Echo Request message. " alt="" coords="805,5,938,44"/>
<area shape="rect" id="node5" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#a1652c3864180133512f7d6499cd684f2" title="This method sends an ICMPv6 error message. " alt="" coords="528,71,662,109"/>
<area shape="rect" id="node15" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#ad28878461d364df3eeac50588479c9c1" title="This method handles an ICMPv6 message. " alt="" coords="528,133,662,172"/>
<area shape="rect" id="node16" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#aa8d41afcd7a8894a7005bc1c32343f7d" title="This method sends an IPv6 datagram. " alt="" coords="486,196,704,221"/>
<area shape="rect" id="node4" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2129,76,2284,115"/>
<area shape="rect" id="node6" href="../../df/d94/group__core-mle-core.html#ga27bbb63f94a4f59d1249fce8baa830ed" title="This method checks if the destination is reachable. " alt="" coords="752,77,991,103"/>
<area shape="rect" id="node7" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1039,121,1201,160"/>
<area shape="rect" id="node8" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1249,121,1413,160"/>
<area shape="rect" id="node10" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1461,184,1631,223"/>
<area shape="rect" id="node9" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1464,59,1628,97"/>
<area shape="rect" id="node14" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1476,121,1616,160"/>
<area shape="rect" id="node11" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="1679,156,1859,181"/>
<area shape="rect" id="node12" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="1907,93,2081,132"/>
<area shape="rect" id="node13" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="1952,156,2036,181"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/core/net/<a class="el" href="../../d0/db7/udp6_8hpp_source.html">udp6.hpp</a></li>
<li>src/core/net/<a class="el" href="../../d4/d07/udp6_8cpp.html">udp6.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><a class="el" href="../../d2/de1/namespaceThread_1_1Ip6.html">Ip6</a></li><li class="navelem"><a class="el" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html">Udp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
